<template>
  <div class="p-2">
    <el-dialog v-model="dialog.visible" :title="dialog.title" width="35%" :draggable="draggable">
      <el-form ref="formRef" v-loading="formLoading" :model="formData" :rules="formRules" label-width="80px">
        <el-form-item label="卡类别" prop="typeName">
          <el-input v-model="formData.typeName" placeholder="请输入卡类别" />
        </el-form-item>
        <el-form-item label="code" prop="code">
          <el-input v-model="formData.code" type="number" placeholder="请输入code值" />
        </el-form-item>
        <el-form-item label="管理费" prop="commissionCharge">
          <el-input v-model="formData.commissionCharge" placeholder="请输入管理费" />
        </el-form-item>
        <el-form-item label="押金" prop="deposit">
          <el-input v-model="formData.deposit" placeholder="请输入押金" />
        </el-form-item>
        <el-form-item label="工本费" prop="productCost">
          <el-input v-model="formData.productCost" placeholder="请输入工本费" />
        </el-form-item>
        <el-form-item label="折旧费" prop="depreciation">
          <el-input v-model="formData.depreciation" placeholder="请输入折旧费" />
        </el-form-item>
        <el-form-item label="状态" prop="status">
          <el-select v-model="formData.status" placeholder="请选择状态">
            <el-option v-for="dict in sys_normal_disable" :key="dict.value" :label="dict.label" :value="dict.value"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="类别说明" prop="typeNotes">
          <el-input v-model="formData.typeNotes" placeholder="请输入类别说明" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="formLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="dialog.visible = false">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="PtCardtypeForm" lang="ts">
import * as PtCardtypeApi from '@/api/basics/basicParameter/ptCardtype';
import { PtCardTypeForm } from '@/api/basics/basicParameter/ptCardtype/types';
import { useI18n } from 'vue-i18n';

defineOptions({ name: 'PtCardtypeForm' });

// 接收父组件传入属性
// const props = defineProps({})

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
// 国际化
const { t } = useI18n();

/** 数据字典 */
const { sys_normal_disable } = toRefs<any>(proxy?.useDict('sys_normal_disable'));
// 对话框
const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});
// 窗体是否可以拖动
const draggable = ref(true);
// 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formLoading = ref(false);
// 表单的类型：create - 新增；update - 修改
const formType = ref('');
// 表单引用
const formRef = ref<ElFormInstance>();
// 表单数据
const formData = ref<PtCardTypeForm>({
  typeId: undefined,
  typeName: '',
  commissionCharge: undefined,
  deposit: undefined,
  productCost: undefined,
  depreciation: undefined,
  status: '',
  typeNotes: '',
  code: undefined
});
// 表单校验规则
const formRules = reactive({
  typeName: [{ required: true, message: '卡类别不能为空', trigger: 'blur' }],
  commissionCharge: [{ required: true, message: '管理费不能为空', trigger: 'blur' }],
  deposit: [{ required: true, message: '押金不能为空', trigger: 'blur' }],
  productCost: [{ required: true, message: '工本费不能为空', trigger: 'blur' }],
  depreciation: [{ required: true, message: '折旧费不能为空', trigger: 'blur' }],
  status: [{ required: true, message: '状态不能为空', trigger: 'change' }],
  code: [{ required: true, message: '状态不能为空', trigger: 'blur' }]
});
/** 当前组件方法 */
/** 窗体打开事件 */
const open = async (type: string, id?: number) => {
  dialog.visible = true;
  dialog.title = t('action.' + type);
  formType.value = type;
  resetForm();
  // 修改时，设置数据
  if (id) {
    formLoading.value = true;
    try {
      const res = await PtCardtypeApi.getPtCardType(id);
      Object.assign(formData.value, res.data);
    } finally {
      formLoading.value = false;
    }
  }
};
/** 表单重置 */
const resetForm = () => {
  formData.value = {
    typeId: undefined,
    typeName: '',
    commissionCharge: undefined,
    deposit: undefined,
    productCost: undefined,
    depreciation: undefined,
    status: '',
    typeNotes: '',
    code: undefined
  };
  formRef.value?.resetFields();
};
// 传回给父组件的属性与方法
// 提供 open 方法，用于打开弹窗
defineExpose({ open });
/** 触发父组件的事件 */
/** 定义 success 事件，用于操作成功后的回调 */
const emit = defineEmits(['success']);
/** 提交按钮 */
const submitForm = async () => {
  // 校验表单
  if (!formRef.value) return;
  const valid = await formRef.value?.validate();
  if (!valid) return;
  // 提交请求
  formLoading.value = true;
  try {
    const data = formData.value as unknown as PtCardTypeForm;
    if (formType.value === 'create') {
      await PtCardtypeApi.addPtCardType(data);
      proxy?.$modal.msgSuccess('新增成功');
    } else {
      await PtCardtypeApi.updatePtCardType(data);
      proxy?.$modal.msgSuccess('修改成功');
    }
    dialog.visible = false;
    // 发送操作成功的事件
    emit('success');
  } finally {
    formLoading.value = false;
  }
};

/** 初始化 */
onMounted(() => {});
</script>
